
package org.apache.servicemix.samples.wsdl_first;

import java.net.MalformedURLException;
import java.util.Collection;
import java.util.HashMap;
import javax.xml.namespace.QName;
import org.codehaus.xfire.XFireRuntimeException;
import org.codehaus.xfire.aegis.AegisBindingProvider;
import org.codehaus.xfire.annotations.AnnotationServiceFactory;
import org.codehaus.xfire.annotations.jsr181.Jsr181WebAnnotations;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.jaxb2.JaxbTypeRegistry;
import org.codehaus.xfire.service.Endpoint;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.soap.AbstractSoapBinding;
import org.codehaus.xfire.transport.TransportManager;

public class PersonServiceClient {

    private static XFireProxyFactory proxyFactory = new XFireProxyFactory();
    private HashMap endpoints = new HashMap();
    private Service service0;

    public PersonServiceClient() {
        create0();
        Endpoint soapEP = service0 .addEndpoint(new QName("http://servicemix.apache.org/samples/wsdl-first", "soap"), new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonSOAPBinding"), "http://localhost:8192/PersonService/");
        endpoints.put(new QName("http://servicemix.apache.org/samples/wsdl-first", "soap"), soapEP);
        Endpoint PersonLocalEndpointEP = service0 .addEndpoint(new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonLocalEndpoint"), new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonLocalBinding"), "xfire.local://PersonService");
        endpoints.put(new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonLocalEndpoint"), PersonLocalEndpointEP);
    }

    public Object getEndpoint(Endpoint endpoint) {
        try {
            return proxyFactory.create((endpoint).getBinding(), (endpoint).getUrl());
        } catch (MalformedURLException e) {
            throw new XFireRuntimeException("Invalid URL", e);
        }
    }

    public Object getEndpoint(QName name) {
        Endpoint endpoint = ((Endpoint) endpoints.get((name)));
        if ((endpoint) == null) {
            throw new IllegalStateException("No such endpoint!");
        }
        return getEndpoint((endpoint));
    }

    public Collection getEndpoints() {
        return endpoints.values();
    }

    private void create0() {
        TransportManager tm = (org.codehaus.xfire.XFireFactory.newInstance().getXFire().getTransportManager());
        HashMap props = new HashMap();
        props.put("annotations.allow.interface", true);
        AnnotationServiceFactory asf = new AnnotationServiceFactory(new Jsr181WebAnnotations(), tm, new AegisBindingProvider(new JaxbTypeRegistry()));
        asf.setBindingCreationEnabled(false);
        service0 = asf.create((org.apache.servicemix.samples.wsdl_first.Person.class), props);
        {
            AbstractSoapBinding soapBinding = asf.createSoap11Binding(service0, new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonSOAPBinding"), "http://schemas.xmlsoap.org/soap/http");
        }
        {
            AbstractSoapBinding soapBinding = asf.createSoap11Binding(service0, new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonLocalBinding"), "urn:xfire:transport:local");
        }
    }

    public Person getsoap() {
        return ((Person)(this).getEndpoint(new QName("http://servicemix.apache.org/samples/wsdl-first", "soap")));
    }

    public Person getsoap(String url) {
        Person var = getsoap();
        org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
        return var;
    }

    public Person getPersonLocalEndpoint() {
        return ((Person)(this).getEndpoint(new QName("http://servicemix.apache.org/samples/wsdl-first", "PersonLocalEndpoint")));
    }

    public Person getPersonLocalEndpoint(String url) {
        Person var = getPersonLocalEndpoint();
        org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
        return var;
    }

}
